import { EventBus, Events, EventWaiter, EventName } from '@eggjs/eventbus-decorator';
import { EggContext } from '@eggjs/tegg-runtime';
type Array<T> = [T] extends [(...args: infer U) => any] ? U : [T] extends [void] ? [] : [T];
export interface Event {
    name: EventName;
    args: Array<any>;
    context?: EggContext;
}
export interface CorkEvents {
    times: number;
    events: Array<Event>;
}
export declare class SingletonEventBus implements EventBus, EventWaiter {
    private readonly emitter;
    private readonly eventContextFactory;
    private readonly eventHandlerFactory;
    private readonly logger;
    private corkIdSequence;
    private readonly corkedEvents;
    /**
     * only use for ensure event will happen
     */
    once<E extends keyof Events>(event: E, listener: Events[E]): this;
    await<E extends keyof Events>(event: E): Promise<Array<Events[E]>>;
    awaitFirst<E extends keyof Events>(...e: Array<E>): Promise<{
        event: EventName;
        args: Array<Events[E]>;
    }>;
    emit<E extends keyof Events>(event: E, ...args: Array<Events[E]>): boolean;
    generateCorkId(): string;
    cork(corkId: string): void;
    uncork(corkId: string): boolean;
    queueEvent(corkId: string, event: Event): void;
    emitWithContext<E extends keyof Events>(parentContext: EggContext, event: E, args: Array<Events[E]>): boolean;
    private doEmitWithContext;
    private doOnceEmit;
    private doEmit;
}
export {};
